SystemOrganization addCategory: #LoomPharo!

LoomProfilerTest subclass: #LoomPharoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LoomPharo'!

!LoomPharoTest methodsFor: 'tests' stamp: 'AlexandreBergel 9/12/2012 15:44'!
testBasic2OLD

	self scenario2.
	profiler profile: (Array with: thread1 with: thread2 with: thread3).
	self waitForScenarioEnd.
	profiler stopProfiling.
	
	"Thread1 consume twice more the CPU than Thead2. Actually, thread2 is sleeping twice much."
	self assert: (profiler consumptionTimeOf: thread1) >= 0.4.
	self assert: (profiler consumptionTimeOf: thread1) < 1.0.

	self assert: (profiler consumptionTimeOf: thread2) >= 0.10.
	self assert: (profiler consumptionTimeOf: thread2) < 0.6.
	
	self assert: (profiler consumptionTimeOf: thread3) > 0.0.
	self assert: (profiler consumptionTimeOf: thread3) < 0.3.
! !

LoomObject subclass: #LoomTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LoomPharo'!

!LoomTime class methodsFor: 'time' stamp: 'AlexandreBergel 9/6/2012 09:50'!
currentTimeAsMilliseconds

	^ Time now asMilliSeconds ! !

Object subclass: #LoomExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LoomPharo'!

!LoomExporter methodsFor: 'exporter' stamp: 'AlexandreBergel 9/6/2012 09:21'!
toVW

	"
	self new toVW
	
	If I'm executed, I generate a st file called Loom-AlexandreBergel.(*version*)-vw5.st in the same folder that contains the image (./contents/resources).
	To import Loom in VW your should have a Loom version already loaded in the VisualWorks image and follow this steps:
	
	1) Remove the Loom package and agree with all the classes removal in the Loom-VWSpecific. 
	2) Create the Loom package again and do right click in the package, select 'file into' and choose the file you exported. 
	3) FInally restore the Loom-VWSpecific package by loading the latest version of it from the public repository.
	
	"
	Gofer new
		squeaksource: 'PackageInfo';
		package: 'PackageInfo-Exporters';
		load.
	
	(Smalltalk at: #VW5PackageExporter)
	        fileOutPackageNamed:  'Loom' 
 	       withNamespace: 'Loom'.
	
	! !

Object subclass: #LoomInspector
	instanceVariableNames: 'workspace profiler refreshProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LoomPharo'!

!LoomInspector methodsFor: 'public' stamp: 'AlexandreBergel 9/6/2012 08:36'!
open
	Smalltalk garbageCollectMost.
	
	workspace := Workspace new.
	workspace toggleStylingActive; open.
	
	profiler := LoomProfiler new profileAllProcesses.

	self refreshAutomatic! !

!LoomInspector methodsFor: 'refreshing' stamp: 'AlexandreBergel 9/12/2012 15:17'!
refresh
	| stream |
	stream := WriteStream on: String new.
	self writeHeaderOn: stream.
	profiler 
		threadsDo: [ :loomThread |  loomThread printOn: stream. stream cr ]
		using: LoomConsumptionSortingStrategy new.
	
	workspace setContent: stream contents.! !

!LoomInspector methodsFor: 'refreshing' stamp: 'AlexandreBergel 9/12/2012 15:22'!
refreshAutomatic
	refreshProcess := [ [ profiler isProfiling ] whileTrue:  [ 
							self refresh.
							(Delay forMilliseconds: 1000) wait. ] ] forkAt: 43.! !

!LoomInspector methodsFor: 'reporting' stamp: 'AlexandreBergel 9/5/2012 19:24'!
writeHeaderOn: stream
	stream nextPutAll: 'Loom Inspector, last refresh ', Time now printString, String cr.! !
